"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// index.ts
var sveltekit_playwright_fetch_mock_exports = {};
__export(sveltekit_playwright_fetch_mock_exports, {
  handle: () => handle_default,
  handleFetch: () => handleFetch,
  mockFetch: () => playwrightMockServerFetch
});
module.exports = __toCommonJS(sveltekit_playwright_fetch_mock_exports);

// src/handle.ts
var COOKIE_NAME = "mockFetch";
var handle = (isPlaywright) => (_0) => __async(void 0, [_0], function* ({ event, resolve }) {
  var _a;
  if (isPlaywright) {
    event.locals.fetchMocks = JSON.parse((_a = event.cookies.get(COOKIE_NAME)) != null ? _a : "{}");
  }
  return resolve(event);
});
var handle_default = handle;

// src/handleFetch.ts
function handleFetch(request, event) {
  const { locals } = event;
  if (locals.fetchMocks) {
    try {
      Object.entries(locals.fetchMocks).forEach(([pattern, response]) => {
        var _a, _b, _c, _d;
        if (request.url.match(new RegExp(pattern))) {
          throw new Response((_a = response.body) != null ? _a : "", {
            status: (_b = response.status) != null ? _b : 200,
            statusText: (_c = response.statusText) != null ? _c : "OK",
            headers: (_d = response.headers) != null ? _d : {}
          });
        }
      });
    } catch (response) {
      if (!(response instanceof Response)) {
        throw new Error("Something other than a response was thrown");
      }
      return response;
    }
  }
  return null;
}

// src/mockFetch.ts
function playwrightMockServerFetch(_0, _1, _2) {
  return __async(this, arguments, function* (page, pattern, body, responseInit = {}) {
    var _a, _b, _c, _d, _e;
    const headers = (_a = responseInit.headers) != null ? _a : {};
    const status = (_b = responseInit.status) != null ? _b : 200;
    const statusText = (_c = responseInit.statusText) != null ? _c : "OK";
    if (typeof body !== "string") {
      body = JSON.stringify(body);
      headers["Content-Type"] = "application/json";
    }
    const cookies = yield page.context().cookies();
    const mocks = JSON.parse(
      (_e = (_d = cookies.find(({ name }) => name === COOKIE_NAME)) == null ? void 0 : _d.value) != null ? _e : "{}"
    );
    const mock = {
      status,
      statusText,
      headers,
      body
    };
    const stringPattern = pattern.toString();
    mocks[stringPattern.slice(1, stringPattern.length - 1)] = mock;
    yield page.context().addCookies([
      {
        name: COOKIE_NAME,
        value: JSON.stringify(mocks),
        domain: "localhost",
        path: "/",
        expires: 1707508488
      }
    ]);
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handle,
  handleFetch,
  mockFetch
});
